unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Grids, DBGrids, DB, FIBDataSet, pFIBDataSet,
  FIBDatabase, pFIBDatabase, FIBQuery, pFIBQuery, DSContainer, Menus;

type
  TFormMain = class(TForm)
    CountryDatabase: TpFIBDatabase;
    WriteTransaction: TpFIBTransaction;
    CountryData: TpFIBDataSet;
    DSCountry: TDataSource;
    DBGridCtr: TDBGrid;
    DBGridPers: TDBGrid;
    Splitter1: TSplitter;
    PersonDatabase: TpFIBDatabase;
    PersonData: TpFIBDataSet;
    DSPerson: TDataSource;
    CountryEdited: TpFIBUpdateObject;
    ReadTransaction: TpFIBTransaction;
    CountryDeleted: TpFIBUpdateObject;
    PersonAdded: TpFIBUpdateObject;
    PersonChanged: TpFIBUpdateObject;
    MainMenu1: TMainMenu;
    MTransaction: TMenuItem;
    MCommit: TMenuItem;
    MRollback: TMenuItem;
    MTransactDatabases: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PersonDataBeforePost(DataSet: TDataSet);
    procedure MCommitClick(Sender: TObject);
    procedure MRollbackClick(Sender: TObject);
    procedure WriteTransactionBeforeStart(Sender: TObject);
    procedure WriteTransactionAfterEnd(EndingTR: TFIBTransaction;
      Action: TTransactionAction; Force: Boolean);
    procedure MTransactDatabasesClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

procedure TFormMain.FormShow(Sender: TObject);
begin
//MTransactDatabasesClick(nil);
  CountryDatabase.Connected := True;
//MTransactDatabasesClick(nil);
  PersonDatabase.Connected := True;
//MTransactDatabasesClick(nil);
  ReadTransaction.StartTransaction;
//MTransactDatabasesClick(nil);
  WriteTransaction.StartTransaction;
  CountryData.Open;
  PersonData.Open;
  DBGridCtr.SetFocus;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CountryData.Close;
  PersonData.Close;
  CountryDatabase.Connected := False;
  PersonDatabase.Connected := False;
end;

procedure TFormMain.PersonDataBeforePost(DataSet: TDataSet);
begin
  PersonAdded.ParamByName('CODCTR').AsString :=
    PersonData.FieldByName('COUNTRY').AsString;
  PersonChanged.ParamByName('CODCTR').AsString :=
    PersonData.FieldByName('COUNTRY').AsString;
end;

procedure TFormMain.MCommitClick(Sender: TObject);
begin
  WriteTransaction.CommitRetaining;
  PersonData.FullRefresh;
end;

procedure TFormMain.MRollbackClick(Sender: TObject);
begin
  WriteTransaction.RollbackRetaining;
  CountryData.FullRefresh;
end;

procedure TFormMain.WriteTransactionBeforeStart(Sender: TObject);
begin
end;

procedure TFormMain.WriteTransactionAfterEnd(EndingTR: TFIBTransaction;
  Action: TTransactionAction; Force: Boolean);
begin
end;

procedure TFormMain.MTransactDatabasesClick(Sender: TObject);
var i: integer;
    S: String;
begin
  S := 'WriteTransaction'+#10#13;
  S := S + 'DatabaseCount: ' + IntToStr(WriteTransaction.DatabaseCount)+#10#13;
  for i := 0 to WriteTransaction.DatabaseCount - 1 do
    S := S + WriteTransaction.Databases[i].Name+#10#13;

  S := S+#10#13 + 'ReadTransaction'+#10#13;
  S := S + 'DatabaseCount: ' + IntToStr(ReadTransaction.DatabaseCount)+#10#13;
  for i := 0 to ReadTransaction.DatabaseCount - 1 do
    S := S + ReadTransaction.Databases[i].Name+#10#13;
  Application.MessageBox(PChar(S),'ReadTransaction',MB_OK);
end;

end.
