unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FIBDatabase, pFIBDatabase, Grids, DBGrids, ComCtrls, ExtCtrls,
  DB, FIBDataSet, pFIBDataSet, StdCtrls, pFIBErrorHandler, fib;

type
  TFormMain = class(TForm)
    Panel1: TPanel;
    DBGridCountry: TDBGrid;
    Database1: TpFIBDatabase;
    Transaction1: TpFIBTransaction;
    DataSetCountry: TpFIBDataSet;
    DataSourceCountry: TDataSource;
    BStartTransaction: TButton;
    BOpenDataSet: TButton;
    BStopTransaction: TButton;
    BCloseDataSet: TButton;
    BCommit: TButton;
    BRollBack: TButton;
    BCharactTransact: TButton;
    BParamTransact: TButton;
    ErrorHandler1: TpFibErrorHandler;
    Splitter1: TSplitter;
    DBGridRegion: TDBGrid;
    DataSetRegion: TpFIBDataSet;
    DataSourceRegion: TDataSource;
    procedure BStartTransactionClick(Sender: TObject);
    procedure BOpenDataSetClick(Sender: TObject);
    procedure BStopTransactionClick(Sender: TObject);
    procedure BCloseDataSetClick(Sender: TObject);
    procedure BCommitClick(Sender: TObject);
    procedure BRollBackClick(Sender: TObject);
    procedure BCharactTransactClick(Sender: TObject);
    procedure BParamTransactClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ErrorHandler1FIBErrorEvent(Sender: TObject;
      ErrorValue: EFIBError; KindIBError: TKindIBError;
      var DoRaise: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

uses TransParam, TransChar;

{$R *.dfm}

procedure TFormMain.BStartTransactionClick(Sender: TObject);
begin
  Transaction1.StartTransaction;
end;

procedure TFormMain.BOpenDataSetClick(Sender: TObject);
begin
  DataSetCountry.Open;
end;

procedure TFormMain.BStopTransactionClick(Sender: TObject);
begin
  Transaction1.Active := False;
end;

procedure TFormMain.BCloseDataSetClick(Sender: TObject);
begin
  DataSetCountry.Close;
end;

procedure TFormMain.BCommitClick(Sender: TObject);
begin
  Transaction1.Commit;
  Transaction1.StartTransaction;
  DataSetCountry.Open;
end;

procedure TFormMain.BRollBackClick(Sender: TObject);
begin
  Transaction1.Rollback;
  Transaction1.StartTransaction;
  DataSetCountry.Open;
end;

procedure TFormMain.BCharactTransactClick(Sender: TObject);
var I: Integer;
begin
  if FormTrans.ShowModal <> IDOK then exit;
  if Transaction1.Active then
    Transaction1.Active := False;
  Transaction1.TRParams.Clear;
  for I := 0 to FormTrans.SelectedParameters.Items.Count - 1 do
    Transaction1.TRParams.Add(
      FormTrans.SelectedParameters.Items[I]);

{(***************************************)
(** Transaction parameter block stuff **)
(***************************************)

  isc_tpb_version1               =          1;
  isc_tpb_version3               =          3;
  isc_tpb_consistency            =          1;
  isc_tpb_concurrency            =          2;
  isc_tpb_shared                 =          3;
  isc_tpb_protected              =          4;
  isc_tpb_exclusive              =          5;
  isc_tpb_wait                   =          6;
  isc_tpb_nowait                 =          7;
  isc_tpb_read                   =          8;
  isc_tpb_write                  =          9;
  isc_tpb_lock_read              =         10;
  isc_tpb_lock_write             =         11;
  isc_tpb_verb_time              =         12;
  isc_tpb_commit_time            =         13;
  isc_tpb_ignore_limbo           =         14;
  isc_tpb_read_committed         =         15;
  isc_tpb_autocommit             =         16;
  isc_tpb_rec_version            =         17;
  isc_tpb_no_rec_version         =         18;
  isc_tpb_restart_requests       =         19;
  isc_tpb_no_auto_undo           =         20;
  isc_tpb_last_tpb_constant      =         isc_tpb_no_auto_undo;
}     
end;

procedure TFormMain.BParamTransactClick(Sender: TObject);
begin
  FormTransactionParam.ShowModal;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  Database1.Open;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Database1.Close;
end;

procedure TFormMain.ErrorHandler1FIBErrorEvent(Sender: TObject;
  ErrorValue: EFIBError; KindIBError: TKindIBError; var DoRaise: Boolean);
var S: String;
begin
  S := S + 'SQLCode = ' + IntToStr(ErrorValue.SQLCode) + #10#13;
  S := S + 'IBErrorCode = ' + IntToStr(ErrorValue.IBErrorCode) + #10#13;
  S := S + 'IBMessage = ' + ErrorValue.IBMessage + #10#13;
  Application.MessageBox(PAnsiChar(S), 'Database Error', MB_OK + MB_ICONSTOP);
  DoRaise := False;
end;

end.
