unit CtrLst;

{$I FIBPlus.inc}

interface

uses
  Windows, Messages, SysUtils,
{$IFDEF D6+}
Variants,
{$ENDIF}
  Classes, Graphics, Controls, Forms,
  Dialogs, DB, FIBDataSet, pFIBDataSet, FIBDatabase, pFIBDatabase, Grids,
  DBGrids, Buttons, ExtCtrls, StdCtrls, ComCtrls, DBCtrls;

type
  TFormMain = class(TForm)
    Panel1: TPanel;
    BExit: TSpeedButton;
    DBGrid1: TDBGrid;
    CountryData: TpFIBDataSet;
    DSCountry: TDataSource;
    Label1: TLabel;
    CSavePoints: TComboBox;
    BSAdd: TButton;
    BSRollback: TButton;
    BSCommit: TButton;
    StatusBar1: TStatusBar;
    Database: TpFIBDatabase;
    WriteTransaction: TpFIBTransaction;
    BSRelease: TButton;
    BSAddExist: TButton;
    procedure BExitClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BSAddClick(Sender: TObject);
    procedure BSRollbackClick(Sender: TObject);
    procedure BSCommitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CountryDataAfterDelete(DataSet: TDataSet);
    procedure BSReleaseClick(Sender: TObject);
    procedure BSAddExistClick(Sender: TObject);
  private
    { Private declarations }
    SavePoint: Integer;
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

procedure TFormMain.BExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  Database.Connected := True;
  WriteTransaction.StartTransaction;
  CountryData.Open;
  SavePoint := 0;
  StatusBar1.Panels.Items[1].Text := IntToStr(CountryData.RecordCount);
  DBGrid1.SetFocus;
end;

procedure TFormMain.BSAddClick(Sender: TObject);
var NewPoint: string;
begin
  SavePoint := SavePoint + 1;
  NewPoint := 'SavePoint' + IntToStr(SavePoint);
  WriteTransaction.SetSavePoint(NewPoint);
  CSavePoints.Items.Add(NewPoint);
  CSavePoints.ItemIndex := CSavePoints.Items.Count - 1;
  DBGrid1.SetFocus;
end;

procedure TFormMain.BSRollbackClick(Sender: TObject);
var NewPoint: string;
    i, NewIndex: Integer;
begin
  if CSavePoints.ItemIndex < 0 then exit;
  NewIndex := CSavePoints.ItemIndex - 1;
  NewPoint := CSavePoints.Items.Strings[CSavePoints.ItemIndex];
  WriteTransaction.RollBackToSavePoint(NewPoint);
  CountryData.FullRefresh;
  for i := CSavePoints.Items.Count - 1 downto NewIndex + 1 do
    CSavePoints.Items.Delete(i);
  CSavePoints.ItemIndex := NewIndex;
  if NewIndex = -1 then CSavePoints.Clear;
  SavePoint := CSavePoints.Items.Count;
  StatusBar1.Panels.Items[1].Text := IntToStr(CountryData.RecordCount);
  DBGrid1.SetFocus;
end;

procedure TFormMain.BSCommitClick(Sender: TObject);
begin
  WriteTransaction.CommitRetaining;
  CountryData.FullRefresh;
  CSavePoints.Items.Clear;
  CSavePoints.ItemIndex := -1;
  SavePoint := 0;
  DBGrid1.SetFocus;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CountryData.Close;
  Database.Connected := False;  
end;

procedure TFormMain.CountryDataAfterDelete(DataSet: TDataSet);
begin
  StatusBar1.Panels.Items[1].Text := IntToStr(CountryData.RecordCount);
end;

procedure TFormMain.BSReleaseClick(Sender: TObject);
var NewPoint: string;
    i, NewIndex: Integer;
begin
  if CSavePoints.ItemIndex < 0 then exit;
  NewIndex := CSavePoints.ItemIndex - 1;
  NewPoint := CSavePoints.Items.Strings[CSavePoints.ItemIndex];
  WriteTransaction.ReleaseSavePoint(NewPoint);
  CountryData.FullRefresh;
  for i := CSavePoints.Items.Count - 1 downto NewIndex + 1 do
    CSavePoints.Items.Delete(i);
  CSavePoints.ItemIndex := NewIndex;
  if NewIndex = -1 then CSavePoints.Clear;
  SavePoint := CSavePoints.Items.Count;
  DBGrid1.SetFocus;
end;

procedure TFormMain.BSAddExistClick(Sender: TObject);
var NewPoint: string;
begin
  if CSavePoints.ItemIndex < 0 then exit;
  NewPoint := CSavePoints.Items.Strings[CSavePoints.ItemIndex];
  CSavePoints.Items.Delete(CSavePoints.ItemIndex);
  WriteTransaction.SetSavePoint(NewPoint);
  CSavePoints.Items.Add(NewPoint);
  CSavePoints.ItemIndex := CSavePoints.Items.Count - 1;
  DBGrid1.SetFocus;
end;

end.
